/*  PRINTSET.H   Header File for PRINTSET program  */

#include "stdio.h"

#define EQUALS  ==           /*  Programmer's Convenience  */
#define AND     &&           /*       "            "       */
#define OR      ||           /*       "            "       */

#define ESC      27          /*  An ASCII escape character     */

#define F1       15104       /*  Function key definitions      */
#define F2       15360
#define F3       15616
#define F4       15872
#define F5       16128
#define F6       16384
#define F7       16640
#define F8       16896
#define F9       17152
#define F10      17408

#define SHFTF1   21504      /*  Shifted F1 key  */
#define CTRLF1   24064      /*  Control F1 key  */
#define ALTF1    26624      /*  Alt F1 key      */

#define SHFTF8   23296      /*  Shifted F8 key  */
#define CTRLF8   25856      /*  Control F8 key  */
#define ALTF8    28416      /*  Alt F8 key      */

#define HOMEKEY  18176       /*  Special Purpose Key Definitions  */
#define UPKEY    18432
#define PGUPKEY  18688
#define LEFTKEY  19200
#define RIGHTKEY 19712
#define ENDKEY   20224
#define DOWNKEY  20480
#define PGDNKEY  20736
#define INSKEY   20992
#define DELKEY   21248
#define CR       13
#define CHOME    30464  /*  CTRL-HOME  */
#define CEND     29952  /*  CTRL-END   */

/*  Definition of major external structures follows                */

struct scrnline {       /* Defines one line of any screen */
    char    row;        /* row on screen, 0 is first entry, 24 is bottom */
    char    col;        /* column on screen, 0 is first column, 79 is last */
    char    bw_attrib;  /* black & white video attribute */
    char    c_attrib;   /* color video attribute */
    char    *text;      /* a pointer to the text string to be displayed */
};

struct barline {        /* Defines one line of any bar menu */
    char    barrow;     /* row on screen, 0 is first entry, 24 is bottom */
    char    barcol;     /* column on screen, 0 is first column, 79 is last */
    char    bbarattr;   /* black & white attribute */
    char    cbarattr;   /* color video attribute */
    char    length;     /* size of bar to be displayed */
};

/*  DIRECTORY SUPPORT STRUCTURES  */

struct filedate {
    int fyear;
    int fmonth;
    int fday;
};

struct filetime {
    int fhours;
    int fmins;
};

struct direct {
    char filename[13];        /* file name followed by '\0'      */
    unsigned char fileattr;   /* file attribute byte             */
    long filesize;            /* size of this file in bytes      */
    struct filedate fdate;    /* file's date                     */
    struct filetime ftime;    /* file's time stamp               */
    struct direct *nextfile;  /* pointer to next directory entry */
};

struct ff_str {
    char dummy[21];           /* reserved for DOS */
    unsigned char attribute;  /* returned attribute */
    unsigned time;
    unsigned date;
    long size;
    unsigned char fn[13];     /* string containing the file name */
};

/*  ======  END OF DIRECTORY SUPPORT STRUCTURE  ============  */

/*  ======  Equipment List =====  */

unsigned floppies;   /* number of floppies in system */
unsigned comms;      /* number of communications ports */
unsigned prints;     /* number of printers */
unsigned display;    /* 1 = color graphics; 0 = monochrome */
unsigned kram;       /* RAM in K */
unsigned char forcebw = 0;

/*  ======  End of Equipment List  ======  */

struct pairs {
    char value;
    char pattr;
};

struct pairs scrn[25][80];  /* screen buffer */

/*  ======  Register declarations for bdos-type calls  ======  */

struct regval { int ax, bx, cx, dx, si, di, ds, es; };

struct regval call_regs, ret_regs;   /* registers used for DOS calls */

/*  ======  End of bdos data declarations  ======  */


